// Generated by CoffeeScript 1.9.1
(function() {
  var TYPES, _rpr, badge, color_code, color_name, effect_name, effect_names, effect_off, effect_on, fn, fn1, isa_text, lines_from_stdout, rainbow_color_names, rainbow_idx, ref,
    slice = [].slice;

  this.constants = require('./TRM-CONSTANTS');

  this.separator = ' ';

  this.depth_of_inspect = 20;

  badge = 'TRM';

  TYPES = require('./TYPES');

  isa_text = TYPES.isa_text.bind(TYPES);

  _rpr = (require('util')).inspect;

  this.ANSI = require('./TRM-VT100-ANALYZER');

  this.rpr = function(x) {
    return _rpr(x, {
      depth: this.depth_of_inspect
    });
  };

  this.get_output_method = function(target, options) {
    return (function(_this) {
      return function() {
        var P;
        P = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        return target.write(_this.pen.apply(_this, P));
      };
    })(this);
  };

  this.pen = function() {
    var P;
    P = 1 <= arguments.length ? slice.call(arguments, 0) : [];

    /* Given any number of arguments, return a text representing the arguments as seen fit for output
    commands like `log`, `echo`, and the colors.
     */
    return (this._pen.apply(this, P)).concat('\n');
  };

  this._pen = function() {
    var P, R, p;
    P = 1 <= arguments.length ? slice.call(arguments, 0) : [];

    /* ... */
    R = (function() {
      var i, len, results;
      results = [];
      for (i = 0, len = P.length; i < len; i++) {
        p = P[i];
        results.push(isa_text(p) ? p : this.rpr(p));
      }
      return results;
    }).call(this);
    return R.join(this.separator);
  };

  this.log = this.get_output_method(process.stderr);

  this.echo = this.get_output_method(process.stdout);

  this.listen_to_keys = function(handler) {

    /* thx to http://stackoverflow.com/a/12506613/256361 */

    /* try not to bind handler to same handler more than once: */
    var R, help, last_key_was_ctrl_c;
    if (handler.__TRM__listen_to_keys__is_registered) {
      return null;
    }
    Object.defineProperty(handler, '__TRM__listen_to_keys__is_registered', {
      value: true,
      enumerable: false
    });
    help = this.get_logger('help', badge);
    last_key_was_ctrl_c = false;
    R = process.openStdin();
    R.setRawMode(true);
    R.setEncoding('utf-8');
    R.resume();
    R.on('data', (function(_this) {
      return function(key) {
        var response;
        response = handler(key);
        if (key === '\u0003') {
          if (last_key_was_ctrl_c) {
            process.exit();
          }
          last_key_was_ctrl_c = true;
          return help("press ctrl-C again to exit");
        } else {
          return last_key_was_ctrl_c = false;
        }
      };
    })(this));
    return R;
  };

  this.ask = function(prompt, handler) {
    var rl;
    rl = (require('readline')).createInterface({
      input: process.stdin,
      output: process.stdout
    });
    if (!/\s+$/.test(prompt)) {
      prompt += ' ';
    }
    return rl.question(this.cyan(prompt), function(answer) {
      rl.close();
      return handler(null, answer);
    });
  };

  lines_from_stdout = function(stdout) {
    var R;
    R = stdout.split('\n');
    if (R[R.length - 1].length === 0) {
      R.length -= 1;
    }
    return R;
  };

  this.spawn = function(command, parameters, handler) {
    var R;
    R = (require('child_process')).spawn(command, parameters, {
      stdio: 'inherit'
    });
    R.on('close', handler);
    return R;
  };

  this.clear_line_right = this.constants.clear_line_right;

  this.clear_line_left = this.constants.clear_line_left;

  this.clear_line = this.constants.clear_line;

  this.clear_below = this.constants.clear_below;

  this.clear_above = this.constants.clear_above;

  this.clear = this.constants.clear;

  this.goto = function(line_nr, column_nr) {
    if (line_nr == null) {
      line_nr = 1;
    }
    if (column_nr == null) {
      column_nr = 1;
    }
    return "\x1b[" + line_nr + ";" + column_nr + "H";
  };

  this.goto_column = function(column_nr) {
    if (column_nr == null) {
      column_nr = 1;
    }
    return "\x1b[" + column_nr + "G";
  };

  this.up = function(count) {
    if (count == null) {
      count = 1;
    }
    return "\x1b[" + count + "A";
  };

  this.down = function(count) {
    if (count == null) {
      count = 1;
    }
    return "\x1b[" + count + "B";
  };

  this.right = function(count) {
    if (count == null) {
      count = 1;
    }
    return "\x1b[" + count + "C";
  };

  this.left = function(count) {
    if (count == null) {
      count = 1;
    }
    return "\x1b[" + count + "D";
  };

  this.move = function(line_count, column_count) {
    return (line_count < 0 ? this.up(line_count) : this.down(line_count)) + (column_count < 0 ? this.left(column_count) : this.right(column_count));
  };

  this.ring_bell = function() {
    return process.stdout.write("\x07");
  };

  effect_names = {
    blink: 1,
    bold: 1,
    reverse: 1,
    underline: 1
  };

  fn = (function(_this) {
    return function(effect_name, effect_on, effect_off) {
      return _this[effect_name] = function() {
        var P, R, i, idx, last_idx, len, p;
        P = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        R = [effect_on];
        last_idx = P.length - 1;
        for (idx = i = 0, len = P.length; i < len; idx = ++i) {
          p = P[idx];
          R.push(isa_text(p) ? p : _this.rpr(p));
          if (idx !== last_idx) {
            R.push(effect_on);
            R.push(_this.separator);
          }
        }
        R.push(effect_off);
        return R.join('');
      };
    };
  })(this);
  for (effect_name in effect_names) {
    effect_on = this.constants[effect_name];
    effect_off = this.constants['no_' + effect_name];
    fn(effect_name, effect_on, effect_off);
  }

  ref = this.constants['colors'];
  fn1 = (function(_this) {
    return function(color_name, color_code) {
      return _this[color_name] = function() {
        var P, R, i, idx, last_idx, len, p;
        P = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        R = [color_code];
        last_idx = P.length - 1;
        for (idx = i = 0, len = P.length; i < len; idx = ++i) {
          p = P[idx];
          R.push(isa_text(p) ? p : _this.rpr(p));
          if (idx !== last_idx) {
            R.push(color_code);
            R.push(_this.separator);
          }
        }
        R.push(_this.constants['reset']);
        return R.join('');
      };
    };
  })(this);
  for (color_name in ref) {
    color_code = ref[color_name];
    fn1(color_name, color_code);
  }

  this.remove_colors = function(text) {
    return text.replace(this.color_matcher, '');
  };

  this.color_matcher = /\x1b\[[^m]*m/g;

  rainbow_color_names = "red orange yellow green blue pink".split(/\s+/);

  rainbow_idx = -1;

  this.rainbow = function() {
    var P;
    P = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    rainbow_idx = (rainbow_idx + 1) % rainbow_color_names.length;
    return this[rainbow_color_names[rainbow_idx]].apply(this, P);
  };

  this.route = function() {
    var P;
    P = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    return this.lime(this.underline.apply(this, P));
  };

  this.truth = function() {
    var P, p;
    P = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    return ((function() {
      var i, len, results;
      results = [];
      for (i = 0, len = P.length; i < len; i++) {
        p = P[i];
        results.push(p ? this.green("✔  " + (this._pen(p))) : this.red("✗  " + (this._pen(p))));
      }
      return results;
    }).call(this)).join('');
  };

  this.get_logger = function(category, badge) {
    var R, colorize, pointer, prefix;
    if (badge == null) {
      badge = null;
    }
    switch (category) {
      case 'plain':
        colorize = null;
        pointer = this.grey(' ▶ ');
        break;
      case 'info':
        colorize = this.BLUE.bind(this);
        pointer = this.grey(' ▶ ');
        break;
      case 'whisper':
        colorize = this.grey.bind(this);
        pointer = this.grey(' ▶ ');
        break;
      case 'urge':
        colorize = this.orange.bind(this);
        pointer = this.bold(this.RED(' ? '));
        break;
      case 'praise':
        colorize = this.GREEN.bind(this);
        pointer = this.GREEN(' ✔ ');
        break;
      case 'debug':
        colorize = this.pink.bind(this);
        pointer = this.grey(' ⚙ ');
        break;
      case 'alert':
        colorize = this.RED.bind(this);
        pointer = this.blink(this.RED(' ⚠ '));
        break;
      case 'warn':
        colorize = this.RED.bind(this);
        pointer = this.bold(this.RED(' ! '));
        break;
      case 'help':
        colorize = this.lime.bind(this);
        pointer = this.gold(' ☛ ');
        break;
      default:
        throw new Error("unknown logger category " + (_rpr(category)));
    }
    prefix = badge != null ? (this.darkgrey(badge)).concat(' ', pointer) : pointer;
    if (colorize != null) {
      R = (function(_this) {
        return function() {
          var P;
          P = 1 <= arguments.length ? slice.call(arguments, 0) : [];
          return _this.log(prefix, colorize.apply(null, P));
        };
      })(this);
    } else {
      R = (function(_this) {
        return function() {
          var P;
          P = 1 <= arguments.length ? slice.call(arguments, 0) : [];
          return _this.log.apply(_this, [prefix].concat(slice.call(P)));
        };
      })(this);
    }
    return R;
  };


  /* TAINT naming unstable, to be renamed */

  this.clean = function(text) {
    var R, chunk, is_ansicode;
    is_ansicode = true;
    R = [];
    return ((function() {
      var i, len, ref1, results;
      ref1 = this.analyze(text);
      results = [];
      for (i = 0, len = ref1.length; i < len; i++) {
        chunk = ref1[i];
        if ((is_ansicode = !is_ansicode)) {
          results.push(chunk);
        }
      }
      return results;
    }).call(this)).join('');
  };

  this._prototype_of_object = Object.getPrototypeOf(new Object());

  this._dir_options = {
    'skip-list-idxs': true,
    'skip-object': true
  };

  this._marker_by_type = {
    'function': '()'
  };

  this.dir = function() {
    var P, arity, i, idx, len, p, r, width, x;
    P = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    switch (arity = P.length) {
      case 0:
        throw new Error("called TRM.dir without arguments");
        break;
      case 1:
        x = P[0];
        break;
      default:
        x = P[P.length - 1];
        for (idx = i = 0, len = P.length; i < len; idx = ++i) {
          p = P[idx];
          if (idx < P.length - 1) {
            this.log(this.rainbow(p));
          }
        }
    }
    width = process.stdout.isTTY ? process.stdout.columns : 108;
    r = (this.rpr(x)).replace(/\n\s*/g, ' ');
    if (r.length > width) {
      r = r.slice(0, +Math.max(5, width - 5) + 1 || 9e9).concat(this.grey(' ...'));
    }
    return this.log('\n'.concat(this.lime(r), '\n', (this._dir(x)).join(this.grey(' ')), '\n'));
  };

  this._dir = function(x) {
    var R, i, j, len, len1, marker, name, names, p, ref1, ref2, role, type;
    R = [];
    ref1 = this._get_prototypes_types_and_property_names(x, []);
    for (i = 0, len = ref1.length; i < len; i++) {
      ref2 = ref1[i], role = ref2[0], p = ref2[1], type = ref2[2], names = ref2[3];
      R.push(this.grey('('.concat(role, ')')));
      R.push(this.orange(type));
      for (j = 0, len1 = names.length; j < len1; j++) {
        name = names[j];
        marker = this._marker_from_type(TYPES.type_of((Object.getOwnPropertyDescriptor(p, name))['value']));
        R.push((this.cyan(name)).concat(this.grey(marker)));
      }
    }
    return R;
  };

  this._is_list_idx = function(idx_txt, length) {
    var ref1;
    if (!/^[0-9]+$/.test(idx_txt)) {
      return false;
    }
    return (0 <= (ref1 = parseInt(idx_txt)) && ref1 < length);
  };

  this._marker_from_type = function(type) {
    var ref1;
    return (ref1 = this._marker_by_type[type]) != null ? ref1 : '|'.concat(type);
  };

  this._get_prototypes_types_and_property_names = function(x, types_and_names) {
    var error, length, name, names, prototype, role, x_;
    role = types_and_names.length === 0 ? 'type' : 'prototype';
    if (x == null) {
      types_and_names.push([role, x, TYPES.type_of(x), []]);
      return types_and_names;
    }
    try {
      names = Object.getOwnPropertyNames(x);
      prototype = Object.getPrototypeOf(x);
    } catch (_error) {
      error = _error;
      if (error['message'] !== 'Object.getOwnPropertyNames called on non-object') {
        throw error;
      }
      x_ = new Object(x);
      names = Object.getOwnPropertyNames(x_);
      prototype = Object.getPrototypeOf(x_);
    }
    try {
      length = x.length;
      if (length != null) {
        names = (function() {
          var i, len, results;
          results = [];
          for (i = 0, len = names.length; i < len; i++) {
            name = names[i];
            if (!this._is_list_idx(name, x.length)) {
              results.push(name);
            }
          }
          return results;
        }).call(this);
      }
    } catch (_error) {
      error = _error;
      if (!error['message'].test(/^Cannot read property 'length' of /)) {
        throw error;
      }
    }
    names.sort();
    types_and_names.push([role, x, TYPES.type_of(x), names]);
    if ((prototype != null) && !(this._dir_options['skip-object'] && prototype === this._prototype_of_object)) {
      this._get_prototypes_types_and_property_names(prototype, types_and_names);
    }
    return types_and_names;
  };

}).call(this);
